---
title: WebGLRenderingContext.getBufferParameter()
slug: Web/API/WebGLRenderingContext/getBufferParameter
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.getBufferParameter()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> returns information about the buffer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">any <var>gl</var>.getBufferParameter(<var>target</var>, <var>pname</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("Glenum")}} specifying the target buffer object. Possible values:
 <ul>
  <li><code>gl.ARRAY_BUFFER</code>: Buffer containing vertex attributes, such as vertex coordinates, texture coordinate data, or vertex color data.</li>
  <li><code>gl.ELEMENT_ARRAY_BUFFER</code>: Buffer used for element indices.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.COPY_READ_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
    <li><code>gl.COPY_WRITE_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
    <li><code>gl.TRANSFORM_FEEDBACK_BUFFER</code>: Buffer for transform feedback operations.</li>
    <li><code>gl.UNIFORM_BUFFER</code>: Buffer used for storing uniform blocks.</li>
    <li><code>gl.PIXEL_PACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
    <li><code>gl.PIXEL_UNPACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>pname</dt>
 <dd>A {{domxref("Glenum")}} specifying information to query. Possible values:
 <ul>
  <li><code>gl.BUFFER_SIZE</code>: Returns a {{domxref("GLint")}} indicating the size of the buffer in bytes.</li>
  <li><code>gl.BUFFER_USAGE</code>: Returns a {{domxref("GLenum")}} indicating the usage pattern of the buffer. This is either:
   <ul>
    <li><code>gl.STATIC_DRAW</code>,</li>
    <li><code>gl.DYNAMIC_DRAW</code>,</li>
    <li><code>gl.STREAM_DRAW</code>.</li>
    <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
     <ul>
      <li><code>gl.STATIC_READ</code>,</li>
      <li><code>gl.DYNAMIC_READ,</code></li>
      <li><code>gl.STREAM_READ</code>,</li>
      <li><code>gl.STATIC_COPY</code>,</li>
      <li><code>gl.DYNAMIC_COPY,</code></li>
      <li><code>gl.STREAM_COPY</code>.</li>
     </ul>
    </li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Depends on the requested information (as specified with <code>pname</code>). Either a {{domxref("GLint")}} or a {{domxref("GLenum")}}.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.getBufferParameter(gl.ARRAY_BUFFER, gl.BUFFER_SIZE);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.5", "getBufferParameter")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glGetBufferParameteriv.xml", "glGetBufferParameteriv")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.3", "getBufferParameter")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glGetBufferParameter.xhtml", "glGetBufferParameter")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.<br>
    <br>
    Adds new <code>target</code> buffers:<br>
    <code>gl.COPY_READ_BUFFER</code>,<br>
    <code>gl.COPY_WRITE_BUFFER</code>,<br>
    <code>gl.TRANSFORM_FEEDBACK_BUFFER</code>,<br>
    <code>gl.UNIFORM_BUFFER</code>,<br>
    <code>gl.PIXEL_PACK_BUFFER</code>,<br>
    <code>gl.PIXEL_UNPACK_BUFFER</code><br>
    <br>
    Adds new <code>usage</code> hints:<br>
    <code>gl.STATIC_READ</code>,<br>
    <code>gl.DYNAMIC_READ</code>,<br>
    <code>gl.STREAM_READ</code>,<br>
    <code>gl.STATIC_COPY</code>,<br>
    <code>gl.DYNAMIC_COPY</code>,<br>
    <code>gl.STREAM_COPY</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.getBufferParameter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.bindBuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.createBuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.deleteBuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bufferData()")}}</li>
 <li>Other buffers: {{domxref("WebGLFramebuffer")}}, {{domxref("WebGLRenderbuffer")}}</li>
</ul>
